<?php 
     require 'vendor/autoload.php';

    Class Helper{

        private $dbc;

        
        public function __construct() {
            
        date_default_timezone_set('Asia/Manila');
        $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcloudsys_prod", "Wakeke123!", "vetcloudsys_textblast") or die(mysqli_connect_error());
        }

        public function getCompanies(){
            $q = mysqli_query($this->dbc, "
                SELECT DISTINCT
                    c.`company`
                FROM `client` c 
                ORDER BY c.`company` ASC
          ");
        
        
            $company = [];  
            if($q->num_rows >  0){
                while ($row = mysqli_fetch_assoc($q)) {
                    
                    array_push($company,$row['company']);
                    
                }
            } 
            return $company;

        }

        public function getData($formData){
            
            $sqlWhere = '';
            $sqlParams = [];

            if(isset($formData['company']) && !empty($formData['company'])){
                $sqlWhere .= ' AND c.`company` LIKE "%' .$formData['company'] . '%"';
            }

            if(isset($formData['status']) && !empty($formData['status']) && $formData['status'] != ''){
                
                $sqlWhere .= ' AND c.`sms_status` = "' .  $formData['status'] . '"'; 
            }

            if(isset($formData['date']) && !empty($formData['date'])){
                /*
                $startDate = date('Y-m-d', strtotime($formData['date'])) . ' 00:00:00';
                $endDate = date('Y-m-d', strtotime($formData['date'])) . ' 23:59:59';  
                $sqlWhere .= " AND c.`sent_date` BETWEEN '". $startDate ."' AND '". $startDate ."'"; 
                */
                
                $date_obj = new DateTime($formData['date']);
                $month =  (int) $date_obj->format('m');
                $day = $date_obj->format('d');
                $year =   (int) $date_obj->format('Y');
                $sqlWhere .= " AND c.`message` LIKE '%".$month."/".$day."/".$year."%'"; 
                
                //echo  " AND c.`message` LIKE '%".$month."/".$day."/".$year."%'"; 
                
            }
            
           
            $sqlString = "SELECT 
                    c.`contact_no`,
                    c.`message`,
                    c.`status`,
                    c.`client`,
                    c.`company`,
                    c.`schedule_date_created`,
                    c.`item`,
                    c.`comment`,
                    c.`date_return`,
                    c.`id`,
                    DATE_FORMAT(c.`sent_date`, '%Y/%m/%d %h:%i:%s') as createdAt
                FROM `client` c
                WHERE c.`id` IS NOT NULL
                ".$sqlWhere."
                AND c.`contact_no` IS NOT NULL
                AND c.`message`  IS NOT NULL
                AND c.`company` IS NOT NULL
                AND c.`client`  IS NOT NULL
                ORDER BY c.`company` ASC";
                
                     //echo  $sqlString ; 

            $q = mysqli_query($this->dbc, $sqlString);
        
            
            return mysqli_fetch_all($q, MYSQLI_ASSOC);
        }
        
        public function updateStatus($id, $status, $sentCtr){
            
            $companies = $this->getCompany($id);
            
            if(isset($companies[0]) && isset($companies[0]['company']) && in_array($companies[0]['company'], ['Buena Vida Animal Clinic'])){
                
                $dateReturn = substr($companies[0]['date_return'], 0, strpos($companies[0]['date_return'], "T"));

                if($status == 'Sent'){
                    
                    $sentCtr = $companies[0]['sent_ctr'] + 1;    
                    if(strtotime($dateReturn) > strtotime($companies[0]['lastDateSent'])){
                        $status = 'Pending Sent';
                    }
                }
                                
            } 
            
            if($sentCtr >  5){
                $status = 'Cant Sent No';    
            }

             if(!mysqli_query($this->dbc, "UPDATE `client` c SET c.`sent_ctr` = '".$sentCtr."', c.`sms_status` = '".$status."', c.`status` = 1, c.`updated_at` = '".date('Y-m-d h:i:s')."', c.`last_date_sent` = '".date('Y-m-d h:i:s')."', c.`sent_date` = '".date('Y-m-d h:i:s')."'  WHERE c.`id` = ".$id.""))
                                 die(mysqli_error($this->dbc));


        }
        
        public function getStatus($vetcloudId){

            $sqlWhere = ' WHERE c.`vetcloud_id` = "' . $vetcloudId . '"';

            $q = mysqli_query($this->dbc, "SELECT 
                    c.`sms_status`,
                    c.`id`,
                    IFNULL(DATE_FORMAT(c.`sent_date`, '%Y-%m-%dT%H:%i:%s'), DATE_FORMAT(c.`updated_at`, '%Y-%m-%dT%H:%i:%s')) AS dateSent
                FROM `client` c
                " . $sqlWhere . " 
                ORDER BY c.`id` DESC
                LIMIT 1
                ");
        
            
            return mysqli_fetch_all($q, MYSQLI_ASSOC);
        }
        
        private function getCompany($id){
            
            $q = mysqli_query($this->dbc, "SELECT 
                  c.`company`,
                  c.`date_return`,
                  c.`sent_ctr`,
                  c.`id`,
                  DATE_FORMAT(c.`last_date_sent`, '%Y-%m-%d') AS lastDateSent
            FROM `client` c
            WHERE c.`id` = " . $id ."
            LIMIT 1
            ");
        
            
            return mysqli_fetch_all($q, MYSQLI_ASSOC);
        }
        
         function getTest(){

            $q = mysqli_query($this->dbc, "SELECT 
                      c.`contact_no`,
                      c.`message`,
                      c.`status`,
                      c.`id`
                FROM `client` c
                WHERE id = 125569
                LIMIT 1
                ");
        
            
            return mysqli_fetch_all($q, MYSQLI_ASSOC);
        }

    }

?>