<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;

Class SendAppointmentSchedule {

    private $dbc;
    public function __construct() {
        date_default_timezone_set('Asia/Manila');
        $this->dbc = mysqli_connect("127.0.0.1:3306", "root", '', "vercloud_import") or die(mysqli_connect_error());
    }

    public function execute() {

        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://test1212.ebarangaysoftware.com/api/SMSSchedule/PendingOneDayBeforeAppointment',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => array(),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        if($response){

            $apiRecords = json_decode($response, true);
            $records = $apiRecords['Records'];
            foreach($records as $record){

                $msg = $this->dbc->real_escape_string($record['Message']);
                $no = $this->dbc->real_escape_string($record['ContactNumber_Client']);

                $q = mysqli_query($this->dbc, "
                    SELECT 
                        c.`contact_no`,
                        c.`message`,
                        c.`status`,
                        c.`id`
                    FROM `client` c
                    WHERE c.`contact_no` = '".$no."' 
                    AND c.`message` = '". $msg."'
                    LIMIT 1
                ");

                if($q->num_rows >  0){
                    while ($row = mysqli_fetch_assoc($q)) {
                        echo " This message is duplicate" . "\n";
                    }
                } else {
                    $insertTo = "('".$no."', '". $msg."', 0)";

                    if(!mysqli_query($this->dbc, "INSERT INTO `client` (`contact_no`, `message`, `status`) VALUES $insertTo "))
                    die(mysqli_error($this->dbc));

                    echo "Message save to " . $record['ContactNumber_Client'] . ' save to server' . "\n" ;
                }     
            }
        }
       
        
    }
}

$sms = new SendAppointmentSchedule();
$sms->execute();