<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;
use SMSGatewayMe\Client\Model\CancelMessageRequest;

Class SendFailedSms {

    private $dbc;
    private $config;
    private $apiClient;
    private $messageClient;
    public function __construct() {
            // Configure client   
            date_default_timezone_set('Asia/Manila');

            $this->config = Configuration::getDefaultConfiguration();
            $this->config->setApiKey('Authorization', 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpc3MiOiJhZG1pbiIsImlhdCI6MTY2NjA3MjU1MCwiZXhwIjo0MTAyNDQ0ODAwLCJ1aWQiOjk1NTgyLCJyb2xlcyI6WyJST0xFX1VTRVIiXX0.wKWW1PkJljCP5FjLDV5kckmf-OAWFXelx9EmYc_X_v8');
            $this->apiClient = new ApiClient($this->config);
            $this->messageClient = new MessageApi($this->apiClient);

    }

    public function execute() {
        
       
        $messages = $this->messageClient->searchMessages(
                        [
                            'filters' => [
                                [
                                    [
                                        'field' => 'device_id',
                                        'operator' => '=',
                                        'value' => '129212'
                                    ],

                                    [
                                        'field' => 'status',
                                        'operator' => '=',
                                        'value' => 'failed'
                                    ]
                                ],
                              
                                             
                           ],   
                           'order_by' => [
                                [
                                    'field' => 'created_at',
                                    'direction' => 'DESC'
                                ]
                            ],

                            'limit' => 100
                        ]
                    );
        
            if($messages){
                $failedMessages = $messages->getResults(); 
                if(count($failedMessages)){

                   foreach ($failedMessages as $failedMessage) {
                        $dateObj = $failedMessage->getCreatedAt();
                        $dateToday = $dateObj->format('Y-m-d');

                        if($dateToday == date('Y-m-d')){
                            //$message = $this->messageClient->getMessage($failedMessage['id']);

                              $cancelled = $this->messageClient->cancelMessages([
                                    new CancelMessageRequest([
                                        'id' => $failedMessage['id']
                                    ])
                              ]);

                              $sendMessages = $this->messageClient->sendMessages([
                                    new SendMessageRequest([
                                        'phoneNumber' => $failedMessage['phoneNo'],
                                        //'phoneNumber' => '09923696065',
                                        'message' => $failedMessage['message'],
                                        'deviceId' => 129212
                                    ])
                                ]);

                            echo "Message sent to: " . $failedMessage['phoneNo'] .  "\n" ;
                        }
                    }
                }
            }
      
       
        
    }
}

$sms = new SendFailedSms();
$sms->execute();