<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;
use SMSGatewayMe\Client\Model\CancelMessageRequest;
use SMSGatewayMe\Client\Api\CallbackApi;
use SMSGatewayMe\Client\Model\CreateCallbackRequest;

Class SmsCallback {

    private $dbc;
    private $config;
    private $apiClient;
    private $messageClient;
    public function __construct() {
            // Configure client   
            date_default_timezone_set('Asia/Manila');

            $this->config = Configuration::getDefaultConfiguration();
            $this->config->setApiKey('Authorization', 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpc3MiOiJhZG1pbiIsImlhdCI6MTY2NjA3MjU1MCwiZXhwIjo0MTAyNDQ0ODAwLCJ1aWQiOjk1NTgyLCJyb2xlcyI6WyJST0xFX1VTRVIiXX0.wKWW1PkJljCP5FjLDV5kckmf-OAWFXelx9EmYc_X_v8');
            $this->apiClient = new ApiClient($this->config);
            $this->messageClient = new MessageApi($this->apiClient);

    }

    public function execute() {
        
       
        // Create callback client
        $callbackClient = new CallbackApi($apiClient);
        
        /**
         * Create Callback Request
         * For valid events, filter types and methods please view the swagger definition
         */
        $createCallbackRequest = new CreateCallbackRequest([
            'name' => 'Callback',
            'event' => 'MESSAGE_SENT',
            'deviceId' => 129212,
            'filterType' => 'contains',
            'filter' => 'hello',
            'method' => 'HTTP',
            'action' => 'http://textblast.vetcloudsys.live/UpdateSmsStatus.php',
            'secret' => 'xyywweerrr'
        ]);
        
        $callback = $callbackClient->createCallback($createCallbackRequest);
        print_r($callback);
      
       
        
    }
}

$sms = new SmsCallback();
$sms->execute();