<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;

Class TestSetAppointment {

    private $dbc;
    public function __construct() {
        date_default_timezone_set('Asia/Manila');
        $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcloudsys_prod", "Wakeke123!", "vetcloudsys_vetcloudsys_textblast_test") or die(mysqli_connect_error());
    }

    public function execute() {
        ini_set('memory_limit', '2048M');

        $apiUrl = 'https://sysman2.veterinarycloudsystem.com';
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $apiUrl . '/api/SMSSchedule/PendingOneDayBeforeAppointment',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => array(),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        if($response){

            $apiRecords = json_decode($response, true);
            $records = $apiRecords['Records'];
            foreach($records as $record){
                
              

                $msg = $this->dbc->real_escape_string($this->composeMessage($record['Message']));
                $no = $this->dbc->real_escape_string($record['ContactNumber_Client']);
                $company = $this->dbc->real_escape_string($record['Name_Company']);
                $client = $this->dbc->real_escape_string($record['Name_Client']);
                $scheduleDateCreated = $this->dbc->real_escape_string($record['DateCreated']);
                $comment = $this->dbc->real_escape_string($record['Comment']);
                $item = $this->dbc->real_escape_string($record['Name_Item']);
                $dateReturn = $this->dbc->real_escape_string($record['DateReturn']);
                $systemId = $this->dbc->real_escape_string($record['UniqueID']);
                $apiServer = $this->dbc->real_escape_string($apiUrl);


                $createdAt = date("Y-m-d h:i:s");
                if($company != 'TextBlast'){
                        $q = mysqli_query($this->dbc, "
                        SELECT 
                            c.`contact_no`,
                            c.`message`,
                            c.`status`,
                            c.`id`
                        FROM `client` c
                        WHERE c.`contact_no` = '".$no."' 
                        AND c.`message` = '". $msg."'
                        AND c.`company` = '". $company."'
                        AND c.`client` = '". $client."'
                        AND c.`vetcloud_id` = '". $systemId."'
                        LIMIT 1
                    ");
                 }

             

                if($q->num_rows >  0){
                    while ($row = mysqli_fetch_assoc($q)) {
                        echo " This message is duplicate" . "\n";
                    }
                } else {
                    
                    $smsStatus = 'Invalid Contact No';
                    $msgId = NULL;
    
                    if($this->validatePhoneNo($no)){
                        $smsStatus = 'New';

                        $insertTo = "('".$no."', '". $msg."', 0, '". $company."', '". $client."', '". $scheduleDateCreated."', '". $createdAt."', '". $comment."', '". $item."', '". $dateReturn."', '". $systemId."', '". $smsStatus."', '". $apiServer."' )";
                        if(!mysqli_query($this->dbc, "INSERT INTO `client` (`contact_no`, `message`, `status`, `company`, `client`, `schedule_date_created`, `created_at`, `comment`, `item`, `date_return`, `vetcloud_id`, `sms_status`, `vetcloud_server`) VALUES $insertTo "))
                        die(mysqli_error($this->dbc));
                    } else {

                        $curl = curl_init();

                        curl_setopt_array($curl, array(
                          CURLOPT_URL => $apiUrl . '/api/SMSSchedule/UpdateSMSScheduleStatus?UniqueID='.urlencode($systemId).'&iTextMo_Status=1',
                          CURLOPT_RETURNTRANSFER => true,
                          CURLOPT_ENCODING => '',
                          CURLOPT_MAXREDIRS => 10,
                          CURLOPT_TIMEOUT => 0,
                          CURLOPT_FOLLOWLOCATION => true,
                          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                          CURLOPT_CUSTOMREQUEST => 'POST',
                          CURLOPT_POSTFIELDS => array(),
                        ));
                        
                        $response = curl_exec($curl);
                        
                        curl_close($curl);

                        $insertTo = "('".$no."', '". $msg."', 0, '". $company."', '". $client."', '". $scheduleDateCreated."', '". $createdAt."', '". $comment."', '". $item."', '". $dateReturn."', '". $systemId."', '". $smsStatus."', '". $apiServer."' )";
                        if(!mysqli_query($this->dbc, "INSERT INTO `client` (`contact_no`, `message`, `status`, `company`, `client`, `schedule_date_created`, `created_at`, `comment`, `item`, `date_return`, `vetcloud_id`, `sms_status`, `vetcloud_server`) VALUES $insertTo "))
                        die(mysqli_error($this->dbc));
                    }
                    
                    echo "Message save to " . $record['ContactNumber_Client'] . ' save to server' . "\n" ;
                }     
            }
        }   
    }
    
    private function composeMessage($msg){
        
        $pattern = '/((http|https)\:\/\/)?[a-zA-Z0-9\.\/\?\:@\-_=#]+\.([a-zA-Z0-9\&\.\/\?\:@\-_=#])*/';
         $string = $msg;
        if (preg_match_all($pattern, $msg, $matches)) {
            
            foreach ($matches as $url) {
                $string = str_replace($url, '', $string);
            }
        } 
        

        return $string;
    }

    public function validatePhoneNo($phoneNo){
        
        $isVAlid = false;
        if(preg_match("/^(09|\+639)\d{9}$/", $phoneNo)) {
            $isVAlid = true;
        }
        
        return $isVAlid;
        
    }
    

}

$sms = new TestSetAppointment();
$sms->execute();