<?php

require 'vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;

header("Content-Type: application/json");
header('Access-Control-Allow-Origin: *');
$api = new Api();
$api->execute();

echo json_encode($api->data);

Class Api {

    private $dbc;
    public $data;

    public function __construct() {
        date_default_timezone_set('Asia/Manila');
        $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcloudsys_prod", "Wakeke123!", "vetcloudsys_textblast2") or die(mysqli_connect_error());
    }
    
     public function execute() {
        
        $this->data = [];
        $q = mysqli_query($this->dbc, "
            SELECT 
                c.`contact_no`,
                c.`message`,
                c.`status`,
                c.`id`,
                c.`company`,
                c.`date_return`
            FROM `client` c
            WHERE c.`sms_status` NOT IN( 'Invalid Contact No','Sent', 'Cancelled')
            LIMIT 1

        ");

         if($q->num_rows > 0){
            $ctr = 0;
            while ($row = mysqli_fetch_assoc($q)) {
                
                if(!in_array($row['company'] , [
                    "Man's Best Friend Veterinary Clinic",
                    "Man's Best Friend Veterinary Clinic - Concepcion",
                    "Man's Best Friend Veterinary Clinic - Masinag",
                    "Man's Best Friend Veterinary Clinic - Bataan",
                    "Man's Best Friend Veterinary Clinic - Naga"])){
                        
                        // if(in_array($row['company'], [
                        //     'ST. HYACINTH ANIMAL CLINIC',
                        //     'ST. HYACINTH ANIMAL CLINIC-Antipolo',
                        //     'Cornerstone Animal Clinic',
                        //     'South Metro Animal Clinic'
                        //     ])){
                        //if($dateReturn == date('Y-m-d') && date('H') >= 6){
                            array_push($this->data, array(
                                'id' => $row['id'],
                                'contact_no' => $row['contact_no'],
                            'message' => $this->composeMessage($row['message'])
                            ));
                            
                       // }
                            
                        // } else {
                        //     $ctr++;
                        //     array_push($this->data, array(
                        //         'id' => $row['id'],
                        //         'contact_no' => $row['contact_no'],
                        //         'message' => $row['message']
                        //     ));
                        // }

                       
                        if($ctr == 40){
                            break;
                        }
                    } else {
                        
                        $dateReturn = substr($row['date_return'], 0, strpos($row['date_return'], "T"));
                        if($dateReturn == date('Y-m-d') && date('H') >= 6){
                            
                            
                          array_push($this->data, array(
                            'id' => $row['id'],
                            'contact_no' => $row['contact_no'],
                            'message' => $this->composeMessage($row['message'])
                            ));
                            if($ctr == 40){
                                break;
                            }
                            
                        }
                       
                    }
            }
        }
     }
     
      private function composeMessage($msg){
        
        $pattern = "/(?i)\b((?:https?:(?:\/{1,3}|[a-z0-9%])|[a-z0-9.\-]+[.](?:com|net|org|edu|gov|mil|aero|asia|biz|cat|coop|info|int|jobs|mobi|museum|name|post|pro|tel|travel|xxx|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cs|cu|cv|cx|cy|cz|dd|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|Ja|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)\/)(?:[^\s()<>{}\[\]]+|\([^\s()]*?\([^\s()]+\)[^\s()]*?\)|\([^\s]+?\))+(?:\([^\s()]*?\([^\s()]+\)[^\s()]*?\)|\([^\s]+?\)|[^\s`!()\[\]{};:'\".,<>?«»“”‘’])|(?:(?<!@)[a-z0-9]+(?:[.\-][a-z0-9]+)*[.](?:com|net|org|edu|gov|mil|aero|asia|biz|cat|coop|info|int|jobs|mobi|museum|name|post|pro|tel|travel|xxx|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cs|cu|cv|cx|cy|cz|dd|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|Ja|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)\b\/?(?!@)))/";
        $string = $msg;
        if (preg_match_all($pattern, $msg, $matches)) {
            
            foreach ($matches as $url) {
                $string = str_replace($url, '', $string);
            }
        } 
        
           if (preg_match_all('/[a-z\d._%+-]+@[a-z\d.-]+\.[a-z]{2,4}\b/i', $string, $matches)) {
            
            foreach ($matches as $url) {
                $string = str_replace($url, '', $string);
            }
        } 
        
        
        
        

        return $string;
    }
}
