<?php

require '../vendor/autoload.php';

use SMSGatewayMe\Client\ApiClient;
use SMSGatewayMe\Client\Configuration;
use SMSGatewayMe\Client\Api\MessageApi;
use SMSGatewayMe\Client\Model\SendMessageRequest;

header("Content-Type: application/json");
header('Access-Control-Allow-Origin: *');
$api = new ApiSchedule();
$api->execute();

echo json_encode($api->data);

Class ApiSchedule {

    private $dbc;
    public $data;

    public function __construct() {
        date_default_timezone_set('Asia/Manila');
               $this->dbc = mysqli_connect("127.0.0.1:3306", "vetcloudsys_prod", "Wakeke123!", "vetcloudsys_textblast") or die(mysqli_connect_error());
    }
    
     public function execute() {
       
        $dateToday = date('Y-m-d');
        $dateYesterday = date('Y-m-d', strtotime($dateToday . ' -1 day'));
        
        $this->data = [];
        $q = mysqli_query($this->dbc, "
            SELECT 
                c.`contact_no`,
                c.`message`,
                c.`status`,
                c.`id`,
                c.`company`,
                c.`date_return`,
                c.`sent_ctr`,
                DATE_FORMAT(c.`last_date_sent`, '%Y-%m-%d') AS lastDateSent
            FROM `client` c
            WHERE c.`sms_status` NOT IN('Sent', 'Invalid Contact No', 'Sent In System', 'Invalid No', 'Resent', 'Cant Sent No')
            AND c.`contact_no` NOT IN ('', '0')
            AND c.`message` NOT IN ('')
            AND c.`created_at` BETWEEN '".$dateYesterday." 00:00:00' AND '".date('Y-m-d')." 23:59:59'
            AND c.`sent_ctr` <= 5
            AND c.`created_at` >= '2024-06-21'
            ORDER BY  CAST(c.`date_return` AS DATE) ASC

        ");
        
            //  CASE
            //         WHEN c.`code` LIKE '%SOAP%' THEN 1
            //         WHEN c.`code` LIKE '%WEL%' THEN 2
            //         ELSE 3
            //     END ASC

         if($q->num_rows > 0){
            $ctr = 0;
            while ($row = mysqli_fetch_assoc($q)) {
                //disabled Sms
                if(!in_array($row['company'], [
                    'Happy Hayop Animal Clinic',
                    'Luxuri Pets',
                    'Luxuri Pet Alabang',
                    'Vetron Animal Clinic',
                    'Lucena Petbliss Veterinary Clinic',
                    'Mindoro Beterinaryo - Victoria Branch',
                    'Akkadia Veterinary Clinic-Main',
                    'Animal Access Veterinary Clinic',
                    'Animal Distrik Veterinary Clinic - Pagadian Branch',
                    'Animal distrik veterinary Molave branch',
                    'Assumpta Dog And Cat Clinic',
                    'Buena Vida Animal Clinic',
                    'Canine-Feline Veterinary Clinic',
                    'Cherupets Dog and Cat Clinic',
                    'Dipolog Beastfriend Veterinary Clinic',
                    'DOC MAVIE`S VETERINARY CLINIC',
                    'FIDES Veterinary Clinic',
                    'Furline Veterinary Clinic',
                    'Hanna Pet Wellness Center',
                    'IVAN`S ANIMAL CLINIC',
                    'Northern Vet Animal Clinic',
                    'Pet Adventure',
                    'Pet Center USA',
                    'Pet Professional Veterinary Clinic',
                    'PetCare Veterinary Clinic',
                    'Reyhan Animal Care Clinic',
                    'St. Augustine Veterinary Clinic',
                    'St. Isidore Veterinary Clinic',
                    'Tagaytay Vet Clinic',
                    'Vetsquare Veterinary Clinic',
                    'South Tails Veterinary Clinic',
                    'Pet Family Animal Clinic & Grooming Center',
                    'AniMed Veterinary Clinic and Grooming Station',
                    'Pines Veterinary Clinic',
                    'APO PET CENTRALE',
                    'ZDB Veterinary Clinic',
                    'EMG Animal Clinic and Veterinary Supply',
                    'Family Pet Care ',
                    'Vital Pet Veterinary Clinic',
                    'Fins and Furs Veterinary Clinic',
                    'Faithful Pets Animal Center and Surgery',
                    'VetterHealth Animal Wellness and Emergency Care Clinic',
                    'Happy Paws Veterinary Clinic',
                    'Pawmily Animal Clinic',
                    'Casas Jamis Veterinary Clinic',
                    'Casas Jamis Veterinary Clinic - Lapasan Branch',
                    'Casas Jamis Veterinary Clinic Agusan',
                    //Temporary SMS OFF
                    'PETWELL ANIMAL CLINIC',
                    'NEAH VETERINARY CLINIC',
                    'Puss and Pooch Veterinary Clinic',
                    'L.Bay Veterinary Clinic Co. ATIMONAN BRANCH',
                    'L.Bay Veterinary Clinic Co. CATANAUAN BRANCH',
                    'L.Bay Veterinary Clinic Co. LOPEZ BRANCH',
                    'ISABELA ANIMATES VETERINARY CLINIC & SUPPLIES - CAUAYAN',
                    'ISABELA ANIMATES VETERINARY CLINIC & SUPPLIES - ILAGAN',
                    'Isabela Animates Veterinary Clinic Santiago',
                    'Vet Street Animal Medical Center',
                    'Maxivet Care Grooming & Veterinary Clinic',
                    'Pet Express SM Grand Central',
                    'Pet Express SM San Lazaro',
                    'Pet Express SM Southmall',
                    'Sudah Veterinary Clinic Grooming And Accessories Inc.',
                    'Sudah Hensonville',
                    'Sudah Veterinary Clinic- Concepcion',
                    'Suda-Arayat',
                    'Sudah Veterinary Clinic-Cutud Branch',
                    'Sudah Veterinary Clinic- Sunset',
                    'Sudah Veterinary Clinic- Mabalacat',
                    'Sudah Veterinary Clinic - San Fernando Pampanga',
                    'Saver Petland Animal Clinic',
                    'Saver Petland Animal Clinic General Santos',
                    'ST. HYACINTH ANIMAL CLINIC',
                    'ST. HYACINTH ANIMAL CLINIC-Antipolo',
                    'Cornerstone Animal Clinic',
                    'D.A.D.S Care Veterinary Clinic and Grooming Center',
                    'FDMD Animal Clinic',
                    'Maxwell Animal Clinic',
                    'PRINCE VETERINARY CLINIC',
                    'Rue Saint-Roch Veterinary Clinic',
                    ' Animal Heart Veterinary Clinic And Grooming Center - Daet Branch',
                    'JNA ANIMAL CLINIC',
                    'Clinica Veterinaria',
                    'Animal Clinic Of Davao'
                ])){
                   //todsys schedule
                    if(!in_array($row['company'] , [
                    "Man's Best Friend Veterinary Clinic",
                    "Man's Best Friend Veterinary Clinic - Concepcion",
                    "Man's Best Friend Veterinary Clinic - Masinag",
                    "Man's Best Friend Veterinary Clinic - Bataan",
                    "Man's Best Friend Veterinary Clinic - Naga"])){
                        
                        
                        $dateReturn = substr($row['date_return'], 0, strpos($row['date_return'], "T"));
                        if($dateReturn >= date('Y-m-d')){
                             $ctr++;


                            if(in_array($row['company'] , ['Pet Pawthority Veterinary Clinic'])){
                                 if(date('H') >= 6){
                                array_push($this->data, array(
                                    'id' => $row['id'],
                                    'contact_no' => $row['contact_no'],
                                    'message' => $this->composeMessage($row['message']),
                                  'sent_ctr' => $row['sent_ctr']
                                ));
                                if($ctr == 1){
                                    break;
                                }
                                 }
                            } else {
                                 array_push($this->data, array(
                                    'id' => $row['id'],
                                    'contact_no' => $row['contact_no'],
                                    'message' => $this->composeMessage($row['message']),
                                  'sent_ctr' => $row['sent_ctr']
                                ));
                                if($ctr == 1){
                                    break;
                                }
                            
                                 
                            }
                             
                          
                        } else {
                            
                            if(date('H') >= 6){
                  
                                if(in_array($row['company'] , ['Buena Vida Animal Clinic'])){
                                    
                                    if(strtotime($dateToday) > strtotime($row['lastDateSent'])){
                                       
                                        $ctr++;
                                        array_push($this->data, array(
                                            'id' => $row['id'],
                                            'contact_no' => $row['contact_no'],
                                            'message' => $this->composeMessage($row['message']),
                                            'sent_ctr' => $row['sent_ctr']
                                        ));
                                    }
                                } else {
                                    
                                    //disabled sms of the said day         
                                    if(date('l') == 'Tuesday'){
                                        
                                        if(!in_array($row['company'], ['Petwise Animal Clinic - Macabebe Branch'])){
                                            $ctr++;
                                            array_push($this->data, array(
                                                'id' => $row['id'],
                                                'contact_no' => $row['contact_no'],
                                                'message' => $this->composeMessage($row['message']),
                                                'sent_ctr' => $row['sent_ctr']
                                            ));
                                        }
                                    } else {
                                        
                                        $ctr++;
                                        array_push($this->data, array(
                                            'id' => $row['id'],
                                            'contact_no' => $row['contact_no'],
                                            'message' => $this->composeMessage($row['message']),
                                            'sent_ctr' => $row['sent_ctr']
                                        ));
                                    }
                                
                                   
                                }
                            
                        
                                if($ctr == 1){
                                    break;
                                }
                            
                            }
                        }
                       
                        
                       
                    } else {
                        
                        $dateReturn = substr($row['date_return'], 0, strpos($row['date_return'], "T"));
                        if($dateReturn == date('Y-m-d') && date('H') >= 6){
                             $ctr++;

                              array_push($this->data, array(
                                'id' => $row['id'],
                                'contact_no' => $row['contact_no'],
                                'message' => $this->composeMessage($row['message']),
                                        'sent_ctr' => $row['sent_ctr']
                                ));
                                if($ctr == 1){
                                    break;
                                }
                            
                        }
                       
                    }   
                }
            }
        }
     }
     
      private function composeMessage($msg){
        
        $pattern = "/(?i)\b((?:https?:(?:\/{1,3}|[a-z0-9%])|[a-z0-9.\-]+[.](?:com|one|net|org|edu|gov|mil|aero|asia|biz|cat|coop|info|int|jobs|mobi|museum|name|post|pro|tel|travel|xxx|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cs|cu|cv|cx|cy|cz|dd|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|Ja|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)\/)(?:[^\s()<>{}\[\]]+|\([^\s()]*?\([^\s()]+\)[^\s()]*?\)|\([^\s]+?\))+(?:\([^\s()]*?\([^\s()]+\)[^\s()]*?\)|\([^\s]+?\)|[^\s`!()\[\]{};:'\".,<>?«»“”‘’])|(?:(?<!@)[a-z0-9]+(?:[.\-][a-z0-9]+)*[.](?:com|net|org|edu|gov|mil|aero|asia|biz|cat|coop|info|int|jobs|mobi|museum|name|post|pro|tel|travel|xxx|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cs|cu|cv|cx|cy|cz|dd|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|Ja|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)\b\/?(?!@)))/";
        $string = $msg;
        if (preg_match_all($pattern, $msg, $matches)) {
            
            foreach ($matches as $url) {
                $string = str_replace($url, '', $string);
            }
        } 
        
           if (preg_match_all('/[a-z\d._%+-]+@[a-z\d.-]+\.[a-z]{2,4}\b/i', $string, $matches)) {
            
            foreach ($matches as $url) {
                $string = str_replace($url, '', $string);
            }
        } 
        
        return $string;
    }

}
