<?php

session_start();

require 'vendor/autoload.php';

use PhpOffice\PhpSpreadsheet\Reader\Csv;

include 'InsertClient.php';

if (isset($_SESSION['id']) && isset($_SESSION['user_name'])) {

    $error = '';
    $success = '';
    if ($_SERVER['REQUEST_METHOD'] === 'POST') {

        $msg = $_POST['text']['message'];
        $insertData = new InsertClient();
        // if($insertData->isSending()){
        //   $error =  'Server is still sending text message';

        // } else {
        $file_mimes = array('text/x-comma-separated-values', 'text/comma-separated-values', 'application/octet-stream', 'application/vnd.ms-excel', 'application/x-csv', 'text/x-csv', 'text/csv', 'application/csv', 'application/excel', 'application/vnd.msexcel', 'text/plain', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');

        if (isset($_FILES['text']['name']['file']) && in_array($_FILES['text']['type']['file'], $file_mimes)) {

            $reader = new Csv();
            $spreadsheet = $reader->load($_FILES['text']['tmp_name']['file']);

            $sheetData = $spreadsheet->getActiveSheet()->toArray();
            array_shift($sheetData);


            $insertData->insertData($sheetData, $msg);
            $success = 'Sms successfully imported';
        } else {

            $error =  'Please put a valid CSV file.';
        }
        // }
    }
    ?>
    <!doctype html>
    <html lang="en">

    <head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Vet Cloud - Text Blast</title>
        <link rel="icon" href="media/images/favicon.ico" type="image/x-icon">
        <!-- Bootstrap CSS -->
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    </head>

    <body>

        <?php include 'navbar.php'; ?>

        <div class="container mt-5">
            <div class="row">
                <div class="col">
                    <?php echo $error; ?>
                    <?php echo $success; ?>
                    <form method="POST" action="/home.php" enctype='multipart/form-data' id="uploadFileForm">
                        <div class="mb-3">
                            <label for="exampleFormControlTextarea1" class="form-label">Message</label>
                            <textarea class="form-control" id="exampleFormControlTextarea1" rows="5" name="text[message]"></textarea>
                        </div>
                        <label for="uploadFile" class="btn btn-primary">
                            Import Client
                        </label>
                        <input id="uploadFile" type="file" name='text[file]' style="display:none;" accept=".csv" />
                    </form>
                </div>
            </div>
        </div>


        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>

        <script src="https://code.jquery.com/jquery-3.6.1.min.js" integrity="sha256-o88AwQnZB+VDvE9tvIXrMQaPlFFSUTR+nldQm1LuPXQ=" crossorigin="anonymous">
        </script>

        <script>
            $('#uploadFile').unbind('change').bind('change', function() {
                $('#uploadFileForm').submit();

            });
        </script>


    </body>

    </html>

<?php
} else {
    header("Location: index.php");
    exit();
}
?>