<?php

session_start();

use PhpOffice\PhpSpreadsheet\Reader\Csv;

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\IOFactory;

require 'vendor/autoload.php';
include 'Helper.php';


if (isset($_SESSION['id']) && isset($_SESSION['user_name'])) {


    $error = '';
    $success = '';

    $helper = new Helper();
    $companies  = $helper->getCompanies();
    $smsStatuses = ['New', 'Invalid Contact No', 'Resent', 'Sent', 'Invalid Message content'];

    if ($_SERVER['REQUEST_METHOD'] === 'POST') {

        $formData = $_POST['field'];
        $datas = $helper->getData($formData);

        ini_set('memory_limit', '2048M');
        set_time_limit(0);

        $rowCtr = 1;

        $spreadsheet = new Spreadsheet();
        $sheet = $spreadsheet->getActiveSheet();
        $sheet->setCellValue('A1', 'Company');
        $sheet->setCellValue('B1', 'Client');
        $sheet->setCellValue('C1', 'Contact No.');
        $sheet->setCellValue('D1', 'Item');
        $sheet->setCellValue('E1', 'Date Returned');
        $sheet->setCellValue('F1', 'Date Sent');
        $sheet->setCellValue('G1', 'Message');
        //    $sheet->setCellValue('D1', 'Message');
        //  $sheet->setCellValue('F1', 'Comment');
        //  $sheet->setCellValue('H1', 'Date Created');

        foreach ($datas as $sentMessage) {
            $rowCtr++;
            $sheet->setCellValue('A' . $rowCtr, $sentMessage['company']);

            $sheet->setCellValue('B' . $rowCtr, $sentMessage['client']);
            $sheet->setCellValue('C' . $rowCtr, $sentMessage['contact_no']);
            $sheet->setCellValue('D' . $rowCtr, $sentMessage['item']);
            //   $sheet->setCellValue('F'.$rowCtr, $sentMessage['comment']);
            $sheet->setCellValue('E' . $rowCtr, $sentMessage['date_return']);
            //   $sheet->setCellValue('H'.$rowCtr, $sentMessage['schedule_date_created']);
            $sheet->setCellValue('F' . $rowCtr, $sentMessage['createdAt']);
            $sheet->setCellValue('G' . $rowCtr, $sentMessage['message']);
        }


        header('Content-type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="text.csv"');
        header('Cache-Control: max-age=0');

        ob_end_clean();
        $writer = IOFactory::createWriter($spreadsheet, 'Csv');
        $writer->setPreCalculateFormulas(false);

        $writer->save('php://output');

        die();
    }
    ?>
    <!doctype html>
    <html lang="en">

    <head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <!-- Bootstrap CSS -->
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    </head>
    <link rel="stylesheet" href="//code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">

    <body>

        <?php include 'navbar.php'; ?>

        <div class="container mt-5">
            <div class="row">
                <div class="col-6">
                    <?php echo $error; ?>
                    <?php echo $success; ?>
                    <form method="POST" action="/sms_report.php">
                        <div class="mb-3">
                            <label for="exampleFormControlTextarea1" class="form-label">Company</label>
                            <select name='field[company]' class='form-control'>
                                <option value=''> All</option>
                                <?php
                                    foreach ($companies as $company) { ?>
                                    <option value="<?php echo $company; ?>"> <?php echo $company; ?></option>
                                <?php
                                    }
                                    ?>
                            </select>
                        </div>
                        <div class="mb-3">
                            <label for="exampleFormControlTextarea1" class="form-label">Status</label>
                            <select name='field[status]' class='form-control'>
                                <option value=''> All</option>
                                <?php
                                    foreach ($smsStatuses as $smsStatus) { ?>
                                    <option value="<?php echo $smsStatus; ?>"> <?php echo $smsStatus; ?></option>
                                <?php
                                    }
                                    ?>
                            </select>
                        </div>
                        <div class="mb-3">
                            <label class="form-label">Date</label>
                            <input type="text" id="datepicker" class='form-control' name='field[date]'></p>
                        </div>
                        <div class="mb-3 text-right">
                            <button type="submit" class='btn btn-primary'> CSV</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>

        <script src="https://code.jquery.com/jquery-3.6.1.min.js" integrity="sha256-o88AwQnZB+VDvE9tvIXrMQaPlFFSUTR+nldQm1LuPXQ=" crossorigin="anonymous">
        </script>
        <script src="https://code.jquery.com/ui/1.13.2/jquery-ui.js"></script>

        <script>
            $(function() {
                $("#datepicker").datepicker();
            });
        </script>
    </body>

    </html>

<?php
} else {
    header("Location: index.php");
    exit();
}
?>