<?php


    use PhpOffice\PhpSpreadsheet\Reader\Csv;

    use PhpOffice\PhpSpreadsheet\Spreadsheet;
    use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
    use PhpOffice\PhpSpreadsheet\IOFactory;

    require 'vendor/autoload.php';
    include 'Helper.php'; 
    

    $error = '';
    $success= '';

    $helper = new Helper();
    $companies  = $helper->getCompanies();
    $datas = [];
    $get = '';
    $smsStatuses = ['New','Invalid Contact No', 'Resent', 'Sent', 'Invalid Message content'];


 

   

    if(!isset($_GET['cx'])){
        return header($_SERVER["SERVER_PROTOCOL"]." 404 Not Found");
    } else {

        $get = $_GET['cx'];

        if(count($_GET) > 1){
            $ctr = 0;
            foreach ($_GET as $key => $d) {
                $ctr++;
                if($key != 'cx') {

                    $get .= '&'. $key;
                }
    
            }

        }
        
        $companyToUrlEncode = array_map('urlencode', $companies);
        if(!in_array(urlencode($get), array_map('strtolower',$companyToUrlEncode))){
            return header($_SERVER["SERVER_PROTOCOL"]." 404 Not Found");
        } 
    }

    if($_SERVER['REQUEST_METHOD'] === 'POST'){
      
        $formData = $_POST['field'];

      
        $formData['company'] =  urldecode($get);
        $datas = $helper->getData($formData);
    }
    
?>
<!doctype html>
    <html lang="en">
    <head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <!-- Bootstrap CSS -->
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">        </head>
        <link rel="stylesheet" href="//code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">

    <body>

        <div class="container mt-5">
            <div class="row">
                <div class="col-6">
                <?php echo $error; ?>
                    <?php echo $success; ?>
                    <form method="POST" action='<?php echo "/sms_status.php?cx=" .urlencode($get); ?>' >
                        <div class="mb-3">
                            <label for="exampleFormControlTextarea1" class="form-label">Status</label>
                            <select name='field[status]' class='form-control'>
                                <option value=''> All</option>
                                <?php 
                                    foreach($smsStatuses as $smsStatus){?>
                                        <option value="<?php echo $smsStatus; ?>"> <?php echo $smsStatus; ?></option>
                                    <?php
                                    }
                                ?>
                            </select>
                        </div>
                        <div class="mb-3">
                            <label class="form-label">Date</label>
                            <input type="text" id="datepicker" class='form-control' name='field[date]' required></p>
                        </div>
                        
                        <div class="mb-3 text-right">
                            <button type="submit" class='btn btn-primary'> Query</button>
                        </div>
                    </form>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                <table class="table">
                    <thead>
                        <tr>
                            <th scope="col">Client</th>
                            <th scope="col">Contact No.</th>
                            <th scope="col">Message</th>
                            <th scope="col">Date Sent</th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php 
                            foreach($datas as $data){ ;?>
                                <tr>
                                    <td> <?php echo $data['client'];?></td>
                                    <td><?php echo $data['contact_no'];?></td>
                                    <td><?php echo $data['message'];?></td>
                                    <td><?php echo $data['createdAt'];?></td>
                                </tr>
                       <?php  }
                        ?>
                        
                    </tbody>
                    </table>
                </div>
            </div>


        </div>
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>

        <script
            src="https://code.jquery.com/jquery-3.6.1.min.js"
            integrity="sha256-o88AwQnZB+VDvE9tvIXrMQaPlFFSUTR+nldQm1LuPXQ="
            crossorigin="anonymous">
        </script>
        <script src="https://code.jquery.com/ui/1.13.2/jquery-ui.js"></script>

        <script>
            $( function() {
                $( "#datepicker" ).datepicker();
            } );
        </script>
   </body>
</html>
<?php 

?>
